function mAP = compute_mAP(truth, results)
% mAP = compute_mAP(truth, results)


nQueries = numel(results);
nTruths = cellfun(@numel,truth,'UniformOutput', false);    
nResults = cellfun(@numel,results,'UniformOutput', false);    


relevances = cellfun(@ismember, results, truth, 'UniformOutput',false); % binary relevances
relevances = cellfun(@double, relevances, 'UniformOutput',false);

numberAtCutoff = cellfun(@cumsum, relevances, 'UniformOutput', false);

oneToN = cellfun(@colon, repmat({1}, nQueries,1), nResults, 'UniformOutput',false);
oneToN = cellfun(@transpose, oneToN, 'UniformOutput',false);

precisionAtCutoff = cellfun(@rdivide, numberAtCutoff, oneToN, 'UniformOutput', false);
pTimesRel = cellfun(@dot, precisionAtCutoff, relevances, 'UniformOutput', false);
averagePrecision = cellfun(@rdivide, pTimesRel, nTruths);

mAP = mean(averagePrecision);
