function precAtR = compute_precision_at_r(truth, results)
% precAtR = compute_precision_at_r(truth, results)


nTruths = cellfun(@numel,truth,'UniformOutput', false);    

logicalRelevant = cellfun(@ismember, results, truth, 'UniformOutput', false);
indexRelevant = cellfun(@find, logicalRelevant, 'UniformOutput', false);

nLessThanR = cellfun(@sum, cellfun(@le, indexRelevant, nTruths, 'UniformOutput', false) , 'UniformOutput', false);
precAtR = cellfun(@rdivide, nLessThanR, nTruths); 

precAtR = mean(precAtR);


return;
