/*
 * CdvsException.h
 *
 *  Created on: Nov 23, 2012
 *      Author: massimo
 */

#pragma once

#include <exception>
#include <string>

namespace mpeg7cdva
{


/**
 * Class defining a specific exception for CDVA.
 */
class CdvaException : public std::exception {
private:
	std::string message;

public:
	/**
	 * Create a new CDVA exception.
	 * @param str the exception message string.
	 */
	CdvaException(std::string str) : message(str)
	{}

	virtual ~CdvaException() throw ()	// no exception allowed here
	{}

	/**
	 * Get the exception message.
	 */
	const char* what() const throw() 	// no exception allowed here
	{
		return message.c_str();
	}
};

}	// end of namespace
