#!/usr/bin/env perl
#
# *** you must install valgrind before running this script ***
# on Ubuntu 14.04 and 15.04:
#	sudo apt-get install valgrind
#
require "setenv.pl";

$TESTOUTPUT="memory-test.log";

print "Running memory test, please wait...\n";

#on Windows, we have no "scriptable" memory test so far...
if ($isWindows) {
	print("No script for memory test available on Windows.\n");
}

#on Linux, use Valgrind:
if ($isLinux) {
	system("$VALGRIND $VALOPTIONS $CDVADEBUG extract $EXTRACTING 256 -n 1 -t -w $WORKSPACE 2> $TESTOUTPUT");
	system("$VALGRIND $VALOPTIONS $CDVADEBUG match $MATCHING 256 256 -n 1 -t -w $WORKSPACE 2>> $TESTOUTPUT");
	system("$VALGRIND $VALOPTIONS $CDVADEBUG match $NONMATCHING 256 256 -n 1 -t -w $WORKSPACE 2>> $TESTOUTPUT");
	system("$VALGRIND $VALOPTIONS $CDVADEBUG retrieve $RETRIEVAL 256 $DATABASE 0 -n 1 -t -w $WORKSPACE 2>> $TESTOUTPUT");
}

print "Done.\n";
